/**
 * C# Arrange of GNUGO 1.2
 * 
 * modified by Muzudho
 * last modified 2015-11-26
 *  
 * eval.c    -> Util_CountLibertyAll.cs
 */
/*
              GNUGO - the game of Go (Wei-Chi)
             Version 1.2   last revised 10-31-95
        Copyright (C) Free Software Foundation, Inc.
                   written by Man L. Li
                   modified by Wayne Iba
     modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                 documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/
using Grayscale.GPL.P___160_Collection_.L500_Collection;
using Grayscale.GPL.P___190_Board______.L063_Word;
using Grayscale.GPL.P___190_Board______.L250_Board;
using Grayscale.GPL.P___300_Taikyoku___.L500_Taikyoku;
using Grayscale.GPL.P160____Collection_.L500_Collection;
using Grayscale.GPL.P340____Liberty____.L250_Liberty;

namespace Grayscale.GPL.P340____Liberty____.L500_LibertyAll
{
    public abstract class Util_CountLibertyAll
    {
        /// <summary>
        /// ]֐Ƃ́AՏ̂ȂF̐΂̃oeB[𐔂Ă܂B
        ///
        /// Gnugo1.2 ł́Aeval ֐B
        /// </summary>
        /// <param name="libertyOfPiece_eachPoint">
        /// F̐΂̂ȂĂ镔ipiecej̃oeB[il̐΂uƂj𐔂܂B
        /// s[X̂AŏɎw肵P ̐͋L^܂B
        /// 
        /// Gnugo1.2 ł́Al ƂÕO[oϐBliberty ̗낤H
        /// eval œeݒ肳A̓e exambordAfindsavrAfindwinrAsuicideŎgp܂B
        /// </param>
        /// <param name="color"> or </param>
        public static void Count_LibertyOfPiece_EachPoint
        (
            out int[,] libertyOfPiece_eachPoint,
            StoneColor color,
            Taikyoku taikyoku
        )
        {
            libertyOfPiece_eachPoint = new int[Const_Board.BOARD_SIZE, Const_Board.BOARD_SIZE];

            // ꂼ̃s[X̃oeB[𐔂܂B
            for (int i = 0; i < Const_Board.BOARD_SIZE; i++)
            {
                for (int j = 0; j < Const_Board.BOARD_SIZE; j++)
                {
                    GobanPoint location = new GobanPointImpl(i, j);
                    if (taikyoku.Goban.LookColor(location) == color)// w̐F̂
                    {
                        int libertyOfPiece; // Gnugo1.2 ł́AO[oϐ lib = 0 łB
                        Util_CountLiberty.Count_LibertyOfPiece(out libertyOfPiece, location, color, taikyoku);
                        libertyOfPiece_eachPoint[i, j] = libertyOfPiece;
                    }
                }
            }
        }
    }
}