/**
 * C# Arrange of GNUGO 1.2
 * 
 * modified by Muzudho
 * last modified 2015-11-28
 *  
 * findopen.c -> Util_Findopen.cs
 */
/*
                 GNUGO - the game of Go (Wei-Chi)
                Version 1.2   last revised 10-31-95
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
        modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                    documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/
using Grayscale.GPL.P___160_Collection_.L500_Collection;
using Grayscale.GPL.P___190_Board______.L063_Word;
using Grayscale.GPL.P___300_Taikyoku___.L500_Taikyoku;
using System.Collections.Generic;

namespace Grayscale.GPL.P403____CompThink__.L037_FindOpen
{
    /// <summary>
    /// Jgʒu\ȎwT܂B
    /// </summary>
    public abstract class Util_FindOpen
    {
        /// <summary>
        /// w肵|CgɂāASẴoeB[JĂXy[XT܂B
        /// 
        /// ċA܂B
        /// 
        /// Gnugo1.2 ł findopen֐B
        /// </summary>
        /// <param name="trayLocations_mutable">\ȓ̂߂̈ʒu̔zBGnugo1.2 ł́AizAjzB</param>
        /// <param name="location">Gnugo1.2ł́A Jg sԍ m = 0`18Aԍ n = 0`18B</param>
        /// <param name="color"> or </param>
        /// <param name="liberty123OfPiece">Gnugo1.2 ł minlib B3ȉ̃oeB[</param>
        /// <param name="taikyoku"></param>
        /// <returns></returns>
        public static bool FindOpenLocations
        (
            List<GobanPoint> trayLocations_mutable,
            GobanPoint location,
            StoneColor color,
            int liberty123OfPiece,
            Taikyoku taikyoku
        )
        {
            // ̈ʒuׂ͂AƂtO𗧂Ă܂B
            taikyoku.MarkingBoard.Done_Current(location);

            // klCo[
            if (!location.IsNorthEnd())//k[łȂ
            {
                if
                (
                    // kׂۂŁB
                    taikyoku.Goban.LookColor_NorthOf(location) == StoneColor.Empty
                    &&
                    // kׂA΂ꏊiREɂȂ邩ȂjłȂ΁B
                    !taikyoku.MyKo.Is_NorthOf(location)
                )
                {
                    // kׂAwƂĒǉB
                    trayLocations_mutable.Add( location.ToNorth());
                    if (trayLocations_mutable.Count == liberty123OfPiece)
                    {
                        // oeB[̐ǉȂ琳IB
                        return true;
                    }
                }
                else if
                (
                    // w肵|Cg̖kׂw̐FŁB
                    taikyoku.Goban.LookColor_NorthOf(location) == color
                    &&
                    taikyoku.MarkingBoard.CanDo_North(location) // k܂ׂĂȂȂ
                )
                {
                    if
                    (
                        Util_FindOpen.FindOpenLocations(trayLocations_mutable, location.ToNorth(), color, liberty123OfPiece, taikyoku)
                        &&
                        trayLocations_mutable.Count == liberty123OfPiece
                    )
                    {
                        return true;
                    }
                }
            }

            // lCo[𒲂ׂ܂B
            if (!location.IsSouthEnd())
            {
                if
                (
                    taikyoku.Goban.LookColor_SouthOf(location) == StoneColor.Empty
                    &&
                    // ׂA΁iREȂjłȂ΁B
                    !taikyoku.MyKo.Is_SouthOf(location)
                )
                {
                    trayLocations_mutable.Add( location.ToSouth());
                    if (trayLocations_mutable.Count == liberty123OfPiece)
                    {
                        return true;
                    }
                }
                else
                {
                    if
                    (
                        taikyoku.Goban.LookColor_SouthOf(location) == color
                        &&
                        taikyoku.MarkingBoard.CanDo_South(location)
                    )
                    {
                        if
                        (
                            Util_FindOpen.FindOpenLocations(trayLocations_mutable, location.ToSouth(), color, liberty123OfPiece, taikyoku)
                            &&
                            trayLocations_mutable.Count == liberty123OfPiece
                        )
                        {
                            return true;
                        }
                    }
                }
            }

            // lCo[𒲂ׂ܂B
            if (location.J != 0)
            {
                if
                (
                    taikyoku.Goban.LookColor_WestOf(location) == StoneColor.Empty
                    &&
                    // ׂA΁iREȂjłȂ΁B
                    taikyoku.MyKo.Is_WestOf(location)
                )
                {
                    trayLocations_mutable.Add( location.ToWest());
                    if (trayLocations_mutable.Count == liberty123OfPiece)
                    {
                        return true;
                    }
                }
                else if
                (
                    taikyoku.Goban.LookColor_WestOf(location) == color
                    &&
                    taikyoku.MarkingBoard.CanDo_West(location)
                )
                {
                    if
                    (
                        Util_FindOpen.FindOpenLocations(trayLocations_mutable, location.ToWest(), color, liberty123OfPiece, taikyoku)
                        &&
                        trayLocations_mutable.Count == liberty123OfPiece
                    )
                    {
                        return true;
                    }
                }
            }

            // lCo[𒲂ׂ܂B
            if (!location.IsEastEnd())
            {
                if
                (
                    taikyoku.Goban.LookColor_EastOf(location) == StoneColor.Empty
                    &&
                    // ׂA΁iREȂjłȂ΁B
                    taikyoku.MyKo.Is_EastOf(location)
                )
                {
                    trayLocations_mutable.Add( location.ToEast());
                    if (trayLocations_mutable.Count == liberty123OfPiece)
                    {
                        return true;
                    }
                }
                else if
                (
                    taikyoku.Goban.LookColor_EastOf(location) == color
                    &&
                    taikyoku.MarkingBoard.CanDo_East(location)
                )
                {
                    if
                    (
                        Util_FindOpen.FindOpenLocations(trayLocations_mutable, location.ToEast(), color, liberty123OfPiece, taikyoku)
                        &&
                        trayLocations_mutable.Count == liberty123OfPiece
                    )
                    {
                        return true;
                    }
                }
            }

            // JĂ|Cg̂Ɏs
            return false;
        }
    }
}