/**
 * C# Arrange of GNUGO 1.2
 * 
 * modified by Muzudho
 * last modified 2015-11-28
 *  
 * fioe.c -> Util_OwnEye.cs
 */
/*
                 GNUGO - the game of Go (Wei-Chi)
                Version 1.2   last revised 10-31-95
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
        modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                    documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/
using Grayscale.GPL.P___160_Collection_.L500_Collection;
using Grayscale.GPL.P___300_Taikyoku___.L500_Taikyoku;
using Grayscale.GPL.P160____Collection_.L500_Collection;


namespace Grayscale.GPL.P403____CompThink__.L075_OwnEye
{
    /// <summary>
    /// ΂ł񂾏ꏊA̖ڂłȂǂׂ܂Bi񍇖@j
    /// Rs[^[̎vlA܂ findnext Ŏg܂B
    /// 
    /// Gnugo1.2 ł fioe֐B
    /// </summary>
    public abstract class Util_OwnEye
    {
        /// <summary>
        /// iRs[^[j̖ڂ֑ł񂾂ƂA^Bi񍇖@j
        /// </summary>
        /// <param name="location">Gnugo1.2 ł́A΂ sԍ i = 0`18Aԍ j = 0`18B</param>
        /// <param name="taikyoku"></param>
        /// <returns></returns>
        public static bool IsOwnEye
        (
            GobanPoint location,
            Taikyoku taikyoku
        )
        {
            // ӂ𒲂ׂ܂B
            if (location.IsNorthEnd())
            {
                if
                (
                    location.IsWestEnd()    // k̊p
                    &&
                    // k̋͂ނQ̐΂iRs[^[j̐FȂB
                    taikyoku.Goban.LookColor(new GobanPointImpl(1, 0)) == taikyoku.MyColor
                    &&
                    taikyoku.Goban.LookColor(new GobanPointImpl(0, 1)) == taikyoku.MyColor
                )
                {
                    return true;
                }
                if
                (
                    location.IsEastEnd()   // kp
                    &&
                    // k̋͂ނQ̐΂iRs[^[j̐FȂB
                    taikyoku.Goban.LookColor(new GobanPointImpl(1, 18)) == taikyoku.MyColor
                    &&
                    taikyoku.Goban.LookColor(new GobanPointImpl(0, 17)) == taikyoku.MyColor
                )
                {
                    return true;
                }

                if
                (
                    // ӂŁARRs[^[̐΂Ȃ
                    taikyoku.Goban.LookColor(new GobanPointImpl(1, location.J)) == taikyoku.MyColor // Rs[^[̐
                    &&
                    // EƂRs[^[̐
                    taikyoku.Goban.LookColor(new GobanPointImpl(0, location.J - 1)) == taikyoku.MyColor
                    &&
                    taikyoku.Goban.LookColor(new GobanPointImpl(0, location.J + 1)) == taikyoku.MyColor
                )
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }

            // ӂ𒲂ׂ܂B
            if (location.IsSouthEnd())
            {
                if
                (
                    location.IsWestEnd()    // 쐼p
                    &&
                    // 쐼̋͂ނQ̐΂Rs[^[̐FȂB
                    taikyoku.Goban.LookColor(new GobanPointImpl(17, 0)) == taikyoku.MyColor
                    &&
                    taikyoku.Goban.LookColor(new GobanPointImpl(18, 1)) == taikyoku.MyColor
                )
                {
                    return true;
                }

                if
                (
                    location.IsEastEnd()   // 쓌
                    &&
                    // 쓌̋͂ނQ̐΂Rs[^[̐FȂB
                    taikyoku.Goban.LookColor(new GobanPointImpl(17, 18)) == taikyoku.MyColor
                    &&
                    taikyoku.Goban.LookColor(new GobanPointImpl(18, 17)) == taikyoku.MyColor
                )
                {
                    return true;
                }

                if
                (
                    // ӂŁARRs[^[̐΂Ȃ
                    taikyoku.Goban.LookColor(new GobanPointImpl(17, location.J)) == taikyoku.MyColor
                    &&
                    taikyoku.Goban.LookColor(new GobanPointImpl(18, location.J - 1)) == taikyoku.MyColor
                    &&
                    taikyoku.Goban.LookColor(new GobanPointImpl(18, location.J + 1)) == taikyoku.MyColor
                )
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }

            // ӂ𒲂ׂ܂B
            if (location.IsWestEnd())
            {
                if
                (
                    // ӂŁARRs[^[̐΂Ȃ
                    taikyoku.Goban.LookColor(new GobanPointImpl(location.I, 1)) == taikyoku.MyColor
                    &&
                    taikyoku.Goban.LookColor(new GobanPointImpl(location.I - 1, 0)) == taikyoku.MyColor
                    &&
                    taikyoku.Goban.LookColor(new GobanPointImpl(location.I + 1, 0)) == taikyoku.MyColor
                )
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }

            // Eӂ𒲂ׂ܂B
            if (location.IsEastEnd())
            {
                if
                (
                    // EӂŁARRs[^[̐΂Ȃ
                    taikyoku.Goban.LookColor(new GobanPointImpl(location.I, 17)) == taikyoku.MyColor
                    &&
                    taikyoku.Goban.LookColor(new GobanPointImpl(location.I - 1, 18)) == taikyoku.MyColor
                    &&
                    taikyoku.Goban.LookColor(new GobanPointImpl(location.I + 1, 18)) == taikyoku.MyColor
                )
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }

            // ̃s[X𒲂ׂ܂B
            if
            (
                // SRs[^[̐΂Ȃ
                taikyoku.Goban.LookColor_NorthOf(location) == taikyoku.MyColor
                &&
                taikyoku.Goban.LookColor_EastOf(location) == taikyoku.MyColor
                &&
                taikyoku.Goban.LookColor_SouthOf(location) == taikyoku.MyColor
                &&
                taikyoku.Goban.LookColor_WestOf(location) == taikyoku.MyColor
            )
            {
                return true;
            }
            else
            {
                return false;
            }
        }
    }
}