/**
 * C# Arrange of GNUGO 1.2
 * 
 * modified by Muzudho
 * last modified 2015-11-28
 *  
 * findwinr.c -> Util_FindWinner.cs
 */
/*
                 GNUGO - the game of Go (Wei-Chi)
                Version 1.2   last revised 10-31-95
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
        modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                    documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/
using Grayscale.GPL.P___160_Collection_.L500_Collection;
using Grayscale.GPL.P___190_Board______.L063_Word;
using Grayscale.GPL.P___190_Board______.L250_Board;
using Grayscale.GPL.P___300_Taikyoku___.L500_Taikyoku;
using Grayscale.GPL.P160____Collection_.L500_Collection;
using Grayscale.GPL.P340____Liberty____.L250_Liberty;
using Grayscale.GPL.P403____CompThink__.L037_FindOpen;
using System.Collections.Generic;

namespace Grayscale.GPL.P403____CompThink__.L500_SasiteWinner
{

    /// <summary>
    /// ̐΂URs[^[̎̓T܂B
    /// 
    /// Rs[^[̎vlɎg܂B
    /// </summary>
    public abstract class Util_FindWinner
    {
        /// <summary>
        /// 邩AU鑊̃s[XT܂B
        /// 
        /// Gnugo1.2 ł findwinner ֐B
        /// </summary>
        /// <param name="out_location">̓   sAԍ</param>
        /// <param name="out_score">Gnugo1.2 ł *val B]l</param>
        /// <param name="libertyOfPiece_eachPoint">
        /// JgF̐΂̃oeB[il̐΂uƂj
        /// 
        /// Gnugo1.2 ł́Al ƂÕO[oϐBliberty ̗낤H
        /// eval œeݒ肳A̓e exambordAfindsavrAfindwinrAsuicideŎgp܂B
        /// </param>
        /// <param name="taikyoku"></param>
        /// <returns></returns>
        public static bool FindSasite
        (
            out GobanPoint out_location,
            out int out_score,
            int[,] libertyOfPiece_eachPoint,
            Taikyoku taikyoku
        )
        {
            // vf 3 ȉ̃XgB
            List<GobanPoint> trayLocations = new List<GobanPoint>(3);// Gnugo1.2 ł́Aꂼvf[3] tizAtjzB

            int tryScore;// Gnugo1.2 ł tval ϐB

            out_location = new GobanPointImpl(-1, -1);// ʒui,j
            out_score = -1;  // ]l

            //
            // oeB[il̒uƂjRȉ̑ilԁj̐΂T܂B
            // ܂AȂĂ΁iFقȂ΂ƂȂĂꍇjA[ɂ΂ƂƂłB
            //
            for (int m = 0; m < Const_Board.BOARD_SIZE; m++)
            {
                for (int n = 0; n < Const_Board.BOARD_SIZE; n++)
                {
                    GobanPoint location = new GobanPointImpl(m, n);
                    if (
                        // ilԁj̐΂uĂB
                        taikyoku.Goban.LookColor(location) == taikyoku.YourColor
                        &&
                        // oeB[ 3ȉB
                        libertyOfPiece_eachPoint[m, n] < 4
                    )
                    {
                        // ꂩtO𗧂ĂĂ߂ɃNA[܂B
                        taikyoku.MarkingBoard.Initmark();

                        int ct = 0; // ċAƂɎg܂Bl 0 ^Ă΍\܂B
                        if
                        (
                            Util_FindOpen.FindOpenLocations(trayLocations, location, taikyoku.YourColor, libertyOfPiece_eachPoint[m, n], taikyoku)
                        )
                        {
                            if (libertyOfPiece_eachPoint[m,n] == 1)
                            {
                                // oeB[ 1 ̑ilԁj̐΂܂B
                                if (out_score < 120) // ]l 120 Ȃ
                                {
                                    // ]l120̎wƂāAxXg[üʒuXV܂B
                                    out_score = 120;
                                    out_location.SetLocation(trayLocations[0]);
                                }
                            }
                            else
                            {
                                // oeB[̐̂Qd[vŁA
                                // 0,1 A0,2 A 1,2 ȂǁAقȂyA u,v ܂B
                                for (int u = 0; u < libertyOfPiece_eachPoint[m,n]; u++)//iRs[^[jƂz
                                {
                                    for (int v = 0; v < libertyOfPiece_eachPoint[m,n]; v++)//ilԁjƂz
                                    {
                                        if (u != v)
                                        {
                                            int libertyOfPiece_a; // Gnugo1.2 ł́AO[oϐ lib = 0 łB
                                            Util_CountLiberty.Count_LibertyOfPiece(out libertyOfPiece_a, trayLocations[u], taikyoku.MyColor, taikyoku);
                                            if (0 < libertyOfPiece_a)    // Óȓ
                                            {
                                                // Rs[^[̐F̐΂iɁju܂B
                                                taikyoku.Goban.Put(trayLocations[u], taikyoku.MyColor);
                                        
                                                // look ahead opponent move
                                                int libertyOfPiece_b; // Gnugo1.2 ł́AO[oϐ lib = 0 łB
                                                Util_CountLiberty.Count_LibertyOfPiece(out libertyOfPiece_b, trayLocations[v], taikyoku.YourColor, taikyoku);
                                                if
                                                (
                                                    1 == libertyOfPiece_a
                                                    &&
                                                    0 < libertyOfPiece_b
                                                )
                                                {
                                                    tryScore = 0;
                                                }
                                                else
                                                {
                                                    tryScore = 120 - 20 * libertyOfPiece_b;
                                                }
                                            
                                                if (out_score < tryScore)
                                                {
                                                    // ]l̍w܂BxXg[üʒuXV܂B
                                                    out_score = tryScore;
                                                    out_location.SetLocation(trayLocations[u]);
                                                }

                                                // iɒuj΂菜܂BՏɖ߂łB
                                                taikyoku.Goban.Put(trayLocations[u], StoneColor.Empty);
                                            }
                                        }
                                    }//v
                                }//u
                            }
                        }
                    }
                }//n
            }//m

            if (out_score > 0)   // wB
            {
                return true;
            }
            else    // ҂̎w̂ɂ͎sB
            {
                return false;
            }
        }
    }
}