/**
 * C# Arrange of GNUGO 1.2
 * 
 * modified by Muzudho
 * last modified 2015-11-28
 *  
 * findpatn.c -> Util_FindOpeningZyoseki.cs
 */
/*
              GNUGO - the game of Go (Wei-Chi)
             Version 1.2   last revised 10-31-95
        Copyright (C) Free Software Foundation, Inc.
                   written by Man L. Li
                   modified by Wayne Iba
     modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                 documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/
using Grayscale.GPL.P___160_Collection_.L500_Collection;
using Grayscale.GPL.P___190_Board______.L063_Word;
using Grayscale.GPL.P___190_Board______.L250_Board;
using Grayscale.GPL.P___300_Taikyoku___.L500_Taikyoku;
using Grayscale.GPL.P___405_CompZyoseki.L500_FindPattern;
using Grayscale.GPL.P___409_ComputerB__.L500_Computer;
using Grayscale.GPL.P160____Collection_.L500_Collection;
using Grayscale.GPL.P330____OpenZyoseki.L500_Opening;
using Grayscale.GPL.P405____CompZyoseki.L075_EmptyRectangle;
using Grayscale.GPL.P405____CompZyoseki.L250_FindLocalZyoseki;

namespace Grayscale.GPL.P405____CompZyoseki.L500_FindOpeningZyoseki
{
    /// <summary>
    /// Ղ̓ƁAp^[́ARs[^[̓T܂B
    /// 
    /// Gnugo1.2 ł findpatn֐B
    /// </summary>
    public class Util_FindOpeningZyoseki
    {
        /// <summary>
        /// ΂ɓĂƂ̕]lB
        /// </summary>
        private const int ZYOSEKI_SCORE = 80;

        /// <summary>
        /// ̓̂߂Ƀ}b`΁ip^[jT܂B
        /// 
        /// Gnugo1.2 ł findpatn֐B
        /// </summary>
        /// <param name="out_location">̓   sAԍ</param>
        /// <param name="out_score">Gnugo1.2 ł val B̎w̕]l</param>
        /// <param name="taikyoku"></param>
        /// <returns></returns>
        public static bool FindPattern
        (
            out GobanPoint out_location,
            out int out_score,
            Taikyoku taikyoku
        )
        {
            GobanPoint tryLocation;// Gnugo1.2 ł́Ati,tj Ƃϐ
            int tryScore;// Gnugo1.2 ł́Atval ƂϐB

            //
            // I[vjO̒΂́AՖʑŜ̂̂łB
            //
            // ܂AՂŐ́iILpCGoccupyjłpicornersj_A
            // ɁAJĂlӂ_Ă܂B
            //

            //----------------------------------------
            // [4] Ō̓̑
            //----------------------------------------
            //
            // OFFłB̒΂ɐiłƂÃtOĂ܂B
            //
            if (taikyoku.OpeningZyosekiFlag[4])
            {
                taikyoku.OpeningZyosekiFlag[4] = false; // ̒΂OFFɂ܂B

                // Õf[^o܂B
                int cnd = ((ComputerPlayerB)taikyoku.ComputerPlayer).NodeNo;
                MoveType movetype = ((ComputerPlayerB)taikyoku.ComputerPlayer).Movetype;
                if (OpeningZyosekiImpl.Opening(out out_location, ref cnd, movetype, taikyoku))
                {
                    taikyoku.OpeningZyosekiFlag[4] = true; // ƓȂA̒΂ONɃZbg܂B
                }
                ((ComputerPlayerB)taikyoku.ComputerPlayer).NodeNo = cnd;

                if (taikyoku.Goban.LookColor(out_location) == StoneColor.Empty)  // uȂ
                {
                    out_score = Util_FindOpeningZyoseki.ZYOSEKI_SCORE;  // ΂̕]l
                    return true;
                }
                else
                {
                    // ΂uȂA̒΂I܂B
                    taikyoku.OpeningZyosekiFlag[4] = false;
                }
            }

            //----------------------------------------
            // [0] k̊p
            //----------------------------------------
            if (taikyoku.OpeningZyosekiFlag[0])
            {
                taikyoku.OpeningZyosekiFlag[0] = false; // tONA[B
                if (Util_EmptyRectangle.IsEmptyRectangle(new GobanPointImpl( 0, 0),new GobanPointImpl( 5, 5),taikyoku))
                {

                    int cnd = 0;
                    MoveType movetype = MoveType.Basic;
                    OpeningZyosekiImpl.Opening(out out_location, ref cnd, movetype, taikyoku);  // ̎̂߂̐Vm[h擾܂B
                    if (OpeningZyosekiImpl.Opening(out out_location, ref cnd, movetype, taikyoku))
                    {
                        taikyoku.OpeningZyosekiFlag[4] = true;
                    }
                    ((ComputerPlayerB)taikyoku.ComputerPlayer).NodeNo = cnd;
                    ((ComputerPlayerB)taikyoku.ComputerPlayer).Movetype = movetype;

                    out_score = Util_FindOpeningZyoseki.ZYOSEKI_SCORE;  // ]l
                    return true;
                }
            }

            //----------------------------------------
            // [1] 쐼̊p
            //----------------------------------------
            if (taikyoku.OpeningZyosekiFlag[1])
            {
                taikyoku.OpeningZyosekiFlag[1] = false;
                if (Util_EmptyRectangle.IsEmptyRectangle(new GobanPointImpl(13, 0), new GobanPointImpl(18, 5),taikyoku))
                {
                    int cnd = 0;
                    MoveType movetype = MoveType.Inverted;
                    OpeningZyosekiImpl.Opening(out out_location, ref cnd, movetype, taikyoku); // ̎̂߂̐Vm[h擾܂B
                    if (OpeningZyosekiImpl.Opening(out out_location, ref cnd, movetype, taikyoku))
                    {
                        taikyoku.OpeningZyosekiFlag[4] = true;
                    }
                    ((ComputerPlayerB)taikyoku.ComputerPlayer).NodeNo = cnd;
                    ((ComputerPlayerB)taikyoku.ComputerPlayer).Movetype = movetype;

                    out_score = Util_FindOpeningZyoseki.ZYOSEKI_SCORE;  // ]l
                    return true;
                }
            }

            //----------------------------------------
            // [2] k̊p
            //----------------------------------------
            if (taikyoku.OpeningZyosekiFlag[2])
            {
                taikyoku.OpeningZyosekiFlag[2] = false;
                if (Util_EmptyRectangle.IsEmptyRectangle(new GobanPointImpl(0, 13), new GobanPointImpl(5, 18),taikyoku))
                {
                    int cnd = 0;
                    MoveType movetype = MoveType.Reflected;
                    OpeningZyosekiImpl.Opening(out out_location, ref cnd, movetype, taikyoku);   // ̎̂߂̐Vm[h擾܂B
                    if (OpeningZyosekiImpl.Opening(out out_location, ref cnd, movetype, taikyoku))
                    {
                        taikyoku.OpeningZyosekiFlag[4] = true;
                    }
                    ((ComputerPlayerB)taikyoku.ComputerPlayer).NodeNo = cnd;
                    ((ComputerPlayerB)taikyoku.ComputerPlayer).Movetype = movetype;

                    out_score = Util_FindOpeningZyoseki.ZYOSEKI_SCORE;  // ]l
                    return true;
                }
            }

            //----------------------------------------
            // [2] 쓌̊p
            //----------------------------------------
            if (taikyoku.OpeningZyosekiFlag[3])
            {
                taikyoku.OpeningZyosekiFlag[3] = false;
                if (Util_EmptyRectangle.IsEmptyRectangle(new GobanPointImpl(13, 13), new GobanPointImpl(18, 18),taikyoku))
                {
                    int cnd = 0;
                    MoveType movetype = MoveType.Inverted_And_Reflected;
                    OpeningZyosekiImpl.Opening(out out_location, ref cnd, movetype, taikyoku);   // ̎̂߂̐Vm[h擾܂B
                    if (OpeningZyosekiImpl.Opening(out out_location, ref cnd, movetype, taikyoku))
                    {
                        taikyoku.OpeningZyosekiFlag[4] = true;
                    }
                    ((ComputerPlayerB)taikyoku.ComputerPlayer).NodeNo = cnd;
                    ((ComputerPlayerB)taikyoku.ComputerPlayer).Movetype = movetype;

                    out_score = Util_FindOpeningZyoseki.ZYOSEKI_SCORE;  // ]l
                    return true;
                }
            }

            //
            // Ӂiedgesj̃ILpCioccupyj
            //

            //----------------------------------------
            // [5] k
            //----------------------------------------
            //
            // Ԃ̖k̋`̈悪ۂȂAłޏꏊ̒΂P܂B̒΂͂̂PӏłB
            //
            if (taikyoku.OpeningZyosekiFlag[5])
            {
                taikyoku.OpeningZyosekiFlag[5] = false;
                if (Util_EmptyRectangle.IsEmptyRectangle(new GobanPointImpl(0, 6), new GobanPointImpl(4, 11),taikyoku))
                {
                    out_location = new GobanPointImpl(3,9);// ̎ẅʒui,j
                    out_score = Util_FindOpeningZyoseki.ZYOSEKI_SCORE;  // ]l
                    return true;
                }
            }

            //----------------------------------------
            // [6] 
            //----------------------------------------
            //
            // Ԃ̓쑤̋`̈悪ۂȂAłޏꏊ̒΂P܂B̒΂͂̂PӏłB
            //
            if (taikyoku.OpeningZyosekiFlag[6])
            {
                taikyoku.OpeningZyosekiFlag[6] = false;
                if (Util_EmptyRectangle.IsEmptyRectangle(new GobanPointImpl(18, 6), new GobanPointImpl(14, 11),taikyoku))
                {
                    out_location = new GobanPointImpl(15, 9);// ̎ẅʒui,j
                    out_score = Util_FindOpeningZyoseki.ZYOSEKI_SCORE;  // ]l
                    return true;
                }
            }

            //----------------------------------------
            // [7] 
            //----------------------------------------
            //
            // Ԃ̐̋`̈悪ۂȂAłޏꏊ̒΂P܂B̒΂͂̂PӏłB
            //
            if (taikyoku.OpeningZyosekiFlag[7])
            {
                taikyoku.OpeningZyosekiFlag[7] = false;
                if (Util_EmptyRectangle.IsEmptyRectangle(new GobanPointImpl(6, 0), new GobanPointImpl(11, 4), taikyoku))
                {
                    out_location = new GobanPointImpl(9, 3);// ̎ẅʒui,j
                    out_score = Util_FindOpeningZyoseki.ZYOSEKI_SCORE;  // ]l
                    return true;
                }
            }

            //----------------------------------------
            // [8] 
            //----------------------------------------
            //
            // Ԃ̓̋`̈悪ۂȂAłޏꏊ̒΂P܂B̒΂͂̂PӏłB
            //
            if (taikyoku.OpeningZyosekiFlag[8])
            {
                taikyoku.OpeningZyosekiFlag[8] = false;
                if (Util_EmptyRectangle.IsEmptyRectangle(new GobanPointImpl(6, 18), new GobanPointImpl(11, 14), taikyoku))
                {
                    out_location = new GobanPointImpl(9, 15);// ̎ẅʒui,j
                    out_score = Util_FindOpeningZyoseki.ZYOSEKI_SCORE;  // ]l
                    return true;
                }
            }

            //
            // Ւ΂̂ǂɂĂ͂܂Ȃ΁B
            //

            out_location = new GobanPointImpl(-1, -1);
            out_score = -1;

            //
            // ǒnIȒ΂T܂B
            //
            for (int m = 0; m < Const_Board.BOARD_SIZE; m++)
            {
                for (int n = 0; n < Const_Board.BOARD_SIZE; n++)
                {
                    GobanPoint mnLocation = new GobanPointImpl(m, n);
                    if
                    (
                        taikyoku.Goban.LookColor(mnLocation) == taikyoku.MyColor // Rs[^[̐
                        &&
                        Util_FindLocalZyoseki.FindPattern(out tryLocation, out tryScore, mnLocation, taikyoku)
                        &&
                        out_score < tryScore   // ]l
                    )
                    {
                        out_score = tryScore;  // ]l
                        out_location.SetLocation(tryLocation);// ̎ẅʒui,j
                    }
                }
            }

            if (out_score > 0)   // ΁ip^[j܂B
            {
                return true;
            }
            else    // ΂͌܂łB
            {
                return false;
            }
        }
    }
}