/**
 * C# Arrange of GNUGO 1.2
 * 
 * modified by Muzudho
 * last modified 2015-11-28
 *  
 * genmove.c -> Util_BestMove.cs
 */
/*
              GNUGO - the game of Go (Wei-Chi)
             Version 1.2   last revised 10-31-95
        Copyright (C) Free Software Foundation, Inc.
                   written by Man L. Li
                   modified by Wayne Iba
     modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                 documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/
using Grayscale.GPL.P___160_Collection_.L500_Collection;
using Grayscale.GPL.P___190_Board______.L063_Word;
using Grayscale.GPL.P___190_Board______.L250_Board;
using Grayscale.GPL.P___300_Taikyoku___.L500_Taikyoku;
using Grayscale.GPL.P160____Collection_.L500_Collection;
using Grayscale.GPL.P340____Liberty____.L250_Liberty;
using Grayscale.GPL.P340____Liberty____.L500_LibertyAll;
using Grayscale.GPL.P403____CompThink__.L075_OwnEye;
using Grayscale.GPL.P403____CompThink__.L250_SasiteSaver;
using Grayscale.GPL.P403____CompThink__.L500_SasiteWinner;
using Grayscale.GPL.P405____CompZyoseki.L500_FindOpeningZyoseki;
using System;

namespace Grayscale.GPL.P407____CompBestMov.L500_BestMove
{
    /// <summary>
    /// Rs[^[̎̓܂B
    /// </summary>
    public abstract class Util_BestMove
    {
        /// <summary>
        /// őPTső񐔁B
        /// </summary>
        public const int MAXTRY = 400;

        /// <summary>
        /// Rs[^[̓܂B
        /// 
        /// Gnugo1.2 ł genmove֐B
        /// </summary>
        /// <param name="out_bestMove">Rs[^[I񂾁AԂ΂̒uꏊ</param>
        /// <param name="taikyoku"></param>
        public static void Generate_BestMove
        (
            out GobanPoint out_bestMove,
            Taikyoku taikyoku
        )
        {
            GobanPoint tryLocation; // Gnugo1.2 ł́A ti, tj ƂϐB
            int bestScore;// Gnugo1.2 ł valϐB]lB
            int tryScore; // Gnugo1.2 ł tvalϐBĎZo]lB
            int try_ = 0;   // gC̐

            // [uƕ]l܂B
            out_bestMove = new GobanPointImpl(-1, -1);
            bestScore = -1;

            // JgF̐΂̃oeB[il̐΂uƂj
            // 
            // Gnugo1.2 ł́Al ƂÕO[oϐBliberty ̗낤H
            // eval œeݒ肳A̓e exambordAfindsavrAfindwinrAsuicideŎgp܂B
            int[,] libertyOfPiece_eachPoint;

            // ilԁĵꂼ̃s[X̃oeB[Ăѐ܂B
            Util_CountLibertyAll.Count_LibertyOfPiece_EachPoint(out libertyOfPiece_eachPoint, taikyoku.YourColor, taikyoku);

            // ̃s[XAU߂肷T܂B
            if (Util_FindWinner.FindSasite(out tryLocation, out tryScore, libertyOfPiece_eachPoint, taikyoku))
            {
                if (bestScore < tryScore) // VőPȂ
                {
                    bestScore = tryScore; // őP̕]lƒuꏊAXV܂B
                    out_bestMove.SetLocation(tryLocation);
                }
            }

            // Ă΁A̃s[X܂B
            if (Util_SasiteSaver.FindSasite(out tryLocation, out tryScore, libertyOfPiece_eachPoint, taikyoku))
            {
                if (bestScore < tryScore) // VőPȂ
                {
                    bestScore = tryScore; // őP̕]lƒuꏊAXV܂B
                    out_bestMove.SetLocation(tryLocation);
                }
            }

            // V̂߂̃[JEv[Ep^[Ɉv邩܂B
            if (Util_FindOpeningZyoseki.FindPattern(out tryLocation, out tryScore, taikyoku))
            {
                if (bestScore < tryScore) // VőPȂ
                {
                    bestScore = tryScore; // őP̕]lƒuꏊAXV܂B
                    out_bestMove.SetLocation(tryLocation);
                }
            }

            // 肪΁A_ɑł܂B
            if (bestScore < 0)
            {
                int count_libertyOfPiece;// Gnugo1.2 ł́AÓIO[oϐ lib łB
                do
                {
                    // s ՕŃ_B
                    out_bestMove.I = taikyoku.Random.Next() % Const_Board.BOARD_SIZE;

                    // ႢCÄ̗
                    if
                    (
                        out_bestMove.OutOfI(2, 16)//0`1sA܂ 17`18sB
                        ||
                        out_bestMove.ContainsI(6, 12)//6`12ŝǂɂB
                    )
                    {
                        // UȂ
                        out_bestMove.I = taikyoku.Random.Next() % Const_Board.BOARD_SIZE;
                        if (out_bestMove.OutOfI(2, 16))//0`1sA܂ 17`18sB
                        {
                            // UȂ
                            out_bestMove.I = taikyoku.Random.Next() % Const_Board.BOARD_SIZE;
                        }
                    }

                    //  Օ Ń_B
                    out_bestMove.J = taikyoku.Random.Next() % Const_Board.BOARD_SIZE;

                    // ႢCÄ̗
                    if
                    (
                        out_bestMove.OutOfJ(2,16)//0`1A܂ 17`18񂾁B
                        || // ܂́A
                        out_bestMove.ContainsJ(6,12)//6`12̂ǂɂB
                    )
                    {
                        // UȂ
                        out_bestMove.J = taikyoku.Random.Next() % Const_Board.BOARD_SIZE;

                        if (out_bestMove.OutOfJ(2, 16))//0`1A܂ 17`18񂾁B
                        {
                            // UȂ
                            out_bestMove.J = taikyoku.Random.Next() % Const_Board.BOARD_SIZE;
                        }
                    }

                    // oeB[𐔂ȂB
                    Util_CountLiberty.Count_LibertyOfPiece(out count_libertyOfPiece, out_bestMove, taikyoku.MyColor, taikyoku);
                    ++try_;
                }
                while
                (
                    try_ < MAXTRY // ܂gCł܂B
                    &&
                    (
                        // ̂R̏̂ǂꂩ𖞂悤ȂAăgC܂B
                        // iPjxXg[uۂB񍇖@肩B
                        // iQjs[X̃oeB[ 0`1 ȂB
                        // iRj̖ڂ𖄂߂ȂB
                        taikyoku.Goban.LookColor(out_bestMove) != StoneColor.Empty
                        ||
                        count_libertyOfPiece < 2
                        ||
                        Util_OwnEye.IsOwnEye(out_bestMove, taikyoku)
                    )
                );
            }

            if (MAXTRY <= try_)  // ő厎s񐔂𒴂ĂARs[^[̓pXB
            {
                taikyoku.Pass++;

                //----------------------------------------
                // Rs[^[̎w\܂B
                //----------------------------------------
                Console.WriteLine("I pass.");
                out_bestMove.SetPass();
            }
            else   // ÓȎww܂B
            {
                taikyoku.Pass = 0;

                //----------------------------------------
                // Rs[^[̎w\܂B
                //----------------------------------------
                Console.Write("my move: ");
                // W̗ԍAAXL[R[hɕϊ܂B
                char a;
                if (out_bestMove.J < 8)
                {
                    a = (char)(out_bestMove.J + 65);
                }
                else
                {
                    a = (char)(out_bestMove.J + 66);
                }            
                Console.Write(a);

                int ii; // Gnugo1.2 ł́Asi 𔽓]ϐ iiB
                ii = Const_Board.BOARD_SIZE - out_bestMove.I;
                if (ii < 10)
                {
                    Console.WriteLine("{0,1}", ii);
                }
                else
                {
                    Console.WriteLine("{0,2}", ii);
                }
            }
        }
    }
}