/**
 * C# Arrange of GNUGO 1.2
 * 
 * modified by Muzudho
 * last modified 2015-11-28
 *  
 * endgame.c -> Util_EndOfGame.cs
 *           -> Scene_EndOfGame.cs
 */
/*
              GNUGO - the game of Go (Wei-Chi)
             Version 1.2   last revised 10-31-95
        Copyright (C) Free Software Foundation, Inc.
                   written by Man L. Li
                   modified by Wayne Iba
     modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                 documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/
using Grayscale.GPL.P___160_Collection_.L500_Collection;
using Grayscale.GPL.P___190_Board______.L063_Word;
using Grayscale.GPL.P___190_Board______.L250_Board;
using Grayscale.GPL.P___300_Taikyoku___.L500_Taikyoku;
using Grayscale.GPL.P160____Collection_.L500_Collection;
using Grayscale.GPL.P190____Board______.L260_PointFugo;
using Grayscale.GPL.P190____Board______.L500_Util;
using Grayscale.GPL.P480____Print______.L500_Print;
using Grayscale.GPL.P490____EndOfGame__.L250_SeitiZi;
using System;
using System.Collections;
using System.Collections.Generic;

namespace Grayscale.GPL.P490____EndOfGame__.L500_EndOfGame
{

    public class Util_EndOfGame
    {
        /// <summary>
        /// Տ̊eꏊɂāA׎lɓF̐΂邩𒲂ׁA
        ///  ̏ꏊL܂B
        /// 
        /// Gnugo1.2 ł createlist֐B񎟌zgpĂADictionaryAList ɕύXB
        /// </summary>
        /// <param name="color"></param>
        /// <param name="out_list_neswStones_asNode_eachPoint">Gnugo1.2 ł́A movelist Ƃ́B</param>
        /// <param name="taikyoku"></param>
        private static void GetNeswStones_AsNode_EachPoint(
            StoneColor color,
            out Dictionary<int,List<int>> out_list_neswStones_asNode_eachPoint,
            Taikyoku taikyoku
        )
        {
            //----------------------------------------
            // ̐
            //----------------------------------------
            //
            // eꏊɂāA׎lɓF̐΂邩𒲂ׁA
            //  ̏ꏊL܂B
            //

            out_list_neswStones_asNode_eachPoint = new Dictionary<int,List<int>>();

            for (int i = 0; i < Const_Board.BOARD_SIZE; i++)
            {
                for (int j = 0; j < Const_Board.BOARD_SIZE; j++)
                {
                    GobanPoint location = new GobanPointImpl(i, j);

                    if (taikyoku.Goban.LookColor(location) == color)//w肵F̐΂ɂ
                    {
                        int node = Util_AboutBoard.GetNodeByLocation(location);//Տ̏ꏊ̒ʂԍ

                        // k쐼̏ꏊB΂ꍇ̂݁B
                        List<int> neswNodes = new List<int>();
                        // ܂Ȁꏊ̎l̗lqL邽߂̃XgpӁB
                        out_list_neswStones_asNode_eachPoint.Add(node, neswNodes);

                        // kׂ𒲂ׂ
                        if (!location.IsNorthEnd())//k[ł͂ȂȂB
                        {
                            if (taikyoku.Goban.LookColor_NorthOf(location) == color)
                            {
                                neswNodes.Add(Util_AboutBoard.GetNodeByLocation(location.ToNorth()));//kׂ̏ꏊǉB
                            }
                        }
                        // ׂ𒲂ׂ
                        if (!location.IsEastEnd())//[ł͂ȂȂB
                        {
                            if (taikyoku.Goban.LookColor_EastOf(location) == color)
                            {
                                neswNodes.Add(Util_AboutBoard.GetNodeByLocation(location.ToEast()));
                            }
                        }
                        // ׂ𒲂ׂ
                        if (!location.IsSouthEnd())//[ł͂ȂȂ
                        {
                            if (taikyoku.Goban.LookColor_SouthOf(location) == color)
                            {
                                neswNodes.Add(Util_AboutBoard.GetNodeByLocation(location.ToSouth()));
                            }
                        }
                        // ׂ𒲂ׂ
                        if (!location.IsWestEnd())//[ł͂ȂȂB
                        {
                            if (taikyoku.Goban.LookColor_WestOf(location) == color)
                            {
                                neswNodes.Add(Util_AboutBoard.GetNodeByLocation(location.ToWest()));
                            }
                        }
                    }
                    // end if for color     
                }
                // End j loop
            }
            // End i loop
        }

        /// <summary>
        /// w肵_ijAlɐڑĂ΂SĐグāAԂ܂B
        /// 
        /// ̌_́AlԂR\[͂Ďw肵܂B
        /// </summary>
        /// <param name="out_connectedStones_asNode">Gnugo1.2 ł́Alistpt ƂÕO[ozB</param>
        /// <param name="humanInput_location">Gnugo1.2 ł́Ai,j ƂϐBlԂR\[ɓ͂_ĂB</param>
        /// <param name="list_neswStones_asNode_eachPoint">Gnugo1.2 ł́A movelist Ƃ́B</param>
        private static void GetConnectedStones_AsNode_FromPoint
        (
            out List<int> out_connectedStones_asNode,
            GobanPoint humanInput_location,
            Dictionary<int, List<int>> list_neswStones_asNode_eachPoint
        )
        {
            out_connectedStones_asNode = new List<int>();

            //
            // ̌_͐ǂ̃tOłB
            //
            // Gnugo1.2 ł color ƂϐA΂̐Fƕ킵̂Ŗ̂ύXB
            //
            CheckFlag_Ending[] counted_onBoard = new CheckFlag_Ending[Const_Board.NODES];

            //
            // SĂ̌_A܂ĂȂƂݒɂ܂B
            //
            for (int node = 0; node < Const_Board.NODES; node++)
            {
                counted_onBoard[node] = CheckFlag_Ending.Yet;
            }

            //
            // lԂR\[͂_ɂ΂ƁAlȂĂ铯F̐΂
            // ̃L[ɓĂ͏oāAA܂B
            //
            // Gnugo1.2 ł́AL[삵ĂAC#Ղł ̂̂g悤ɕύXB
            //
            Queue queue_connectedNodes = new Queue(150);

            // lԂw肵_ `FbNς݂ɂAL[ɒǉ܂B
            counted_onBoard[Util_AboutBoard.GetNodeByLocation(humanInput_location)] = CheckFlag_Ending.Working;
            queue_connectedNodes.Enqueue(Util_AboutBoard.GetNodeByLocation(humanInput_location));
#if DEBUG 
            Console.WriteLine("Survived first enqueue in bfslist.");
#endif

            //
            // L[ɂȂ܂ŁA̘AJԂ܂B
            //
            while (queue_connectedNodes.Count != 0)
            {
                // ܂AlԂɎw肳ꂽ_Bi[v̂QTڂ́A̗אڂ΁j
                int node_a = (int)queue_connectedNodes.Dequeue();

                // w肳ꂽ_́A݂k쐼ׂ̐΁BiɒׂĔzɓĂ܂j
                for (int nesw = 0; nesw < list_neswStones_asNode_eachPoint[node_a].Count; nesw++)//
                {
                    // ̖k쐼ׂ̐΂ɂ
                    int node_b = list_neswStones_asNode_eachPoint[node_a][nesw];

                    // ܂ĂȂ
                    if (counted_onBoard[node_b] == CheckFlag_Ending.Yet)
                    {
                        // ̌_ɂ͍ƒtO𗧂āA
                        // ̌_iׂ̐΁jAɔ肷΂ƂăL[ɒǉ܂BAIȓɂȂ܂B
                        counted_onBoard[node_b] = CheckFlag_Ending.Working;
                        queue_connectedNodes.Enqueue(node_b); // 
                    }
                }
#if DEBUG 
                Console.WriteLine("Just prior to first dequeue!.");
#endif

                // lԂɎw肳ꂽ_i[v̂QTڂ́A̗אڂ΁j́A
                // グΏۂOAԋpp̃Xgɒǉ܂B
                counted_onBoard[node_a] = CheckFlag_Ending.Finished;
                out_connectedStones_asNode.Add( node_a); 
            }
        }

        /// <summary>
        /// ł΂̂ȂAՏォ폜܂B
        /// 
        /// Gnugo1.2 ł́Aendgame֐B
        /// </summary>
        /// <param name="taikyoku"></param>
        public static void Remove_DeadPieces(Taikyoku taikyoku)
        {
            bool isContinuePhase; // Gnugo1.2 ł cont ƂϐBcontinue̗낤H

            //
            // ŏɃRs[^[𒲂ׁAɐlԑ𒲂ׂ܂B
            // Տ̊e_̐΂Aǂ̕ɗאڂ΂Ă邩𒲂ׂĂ܂B
            //

            // Rs[^[
            Dictionary<int, List<int>> myList_neswStones_asNode_eachPoint;// Gnugo1.2 ł́Amymovelist ƂϐBint mymovelist[NODES][5]B
            Util_EndOfGame.GetNeswStones_AsNode_EachPoint(taikyoku.MyColor, out myList_neswStones_asNode_eachPoint, taikyoku);

            // lԑ
            Dictionary<int, List<int>> yourList_neswStones_asNode_eachPoint;// Gnugo1.2 ł́Aumovelist ƂϐBint umovelist[NODES][5];B
            Util_EndOfGame.GetNeswStones_AsNode_EachPoint(taikyoku.YourColor, out yourList_neswStones_asNode_eachPoint, taikyoku);

            isContinuePhase = true;
            GobanPoint location;// Gnugo1.2 ł́A i, j ƂϐB
            do
            {
                Console.Write("Dead piece? ");

                // ł΂̏ꏊ͂ĂB
                string an_str = Console.ReadLine();
                //scanf("%s", an);

                //----------------------------------------
                // Óȓ͂܂ŁA邭񂵂܂B
                //----------------------------------------
                {//2015-11-27 ǉ
                    bool valid = false;

                    if (an_str == "stop")
                    {
                        valid = true;
                        location = null;
                    }
                    else
                    {
                        valid = PointFugoImpl.TryParse(an_str, out location);
                    }

                    if (!valid)
                    {
                        // ͂sÓȂ̂ŁA[vB
                        goto gt_DeadPieceContinue;
                    }
                }

                if (an_str == "stop")
                {
                    // [v甲܂B
                    isContinuePhase = false;
                    goto gt_DeadPieceContinue;
                }
                else
                {
                    if (taikyoku.Goban.LookColor(location) == taikyoku.MyColor)
                    {
#if DEBUG
                        Console.WriteLine("Just before bfslist.");
#endif
                        List<int> nodeList;
                        Util_EndOfGame.GetConnectedStones_AsNode_FromPoint(out nodeList, location, myList_neswStones_asNode_eachPoint);
#if DEBUG
                        Console.WriteLine("Survived first bfslist.");
#endif
                        // ꂽꏊɂĂARs[^[̎ꂽ΃JEg𑝂₵܂B
                        foreach(int node in nodeList)
                        {
                            Util_AboutBoard.GetLocationByNode(node, out location);
                            taikyoku.Goban.Put(location, StoneColor.Empty);
                            taikyoku.Count_MyCaptured++;
                        }
                    }
                    else if (taikyoku.Goban.LookColor(location) == taikyoku.YourColor)
                    {
#if DEBUG
                        Console.WriteLine("Just before second bfslist.");
#endif
                        List<int> nodeList;
                        Util_EndOfGame.GetConnectedStones_AsNode_FromPoint(out nodeList, location, yourList_neswStones_asNode_eachPoint);

                        // ꂽꏊɂĂAlԂ̎ꂽ΃JEg𑝂₵܂B
                        foreach (int node in nodeList)
                        {
                            Util_AboutBoard.GetLocationByNode(node, out location);
                            taikyoku.Goban.Put(location, StoneColor.Empty);
                            taikyoku.Count_YourCaptured++;
                        }
                    }
                    Util_PrintBoard.ShowBoard(taikyoku);
                }

            gt_DeadPieceContinue:
                ;
            }
            while (isContinuePhase);
        }

        /// <summary>
        /// ǂ̒niwnjłȂ_A̐΂Ō݂ɖ߂܂B
        /// </summary>
        public static void FillNeutralTerritories
        (
            Taikyoku taikyoku
        )
        {
            bool isContinuePhase = true; // Gnugo1.2 ł cont ƂϐBcontinue̗낤H
            int youMeCounter = 0;//𔽓]邽߂̃JE^[

            GobanPoint location;// Gnugo1.2 ł́A i, j ƂϐB
            do
            {
                if (youMeCounter % 2 == 0)
                {
                    //
                    // w肵ꏊARs[^[̐΂ɒu鏈łB
                    //
                    Console.Write("Your piece? ");

                    string an_str = Console.ReadLine();
                    //scanf("%s", an);

                    //----------------------------------------
                    // Óȓ͂܂ŁA邭񂵂܂B
                    //----------------------------------------
                    {//2015-11-27 ǉ
                        bool valid = false;

                        if (an_str == "stop")
                        {
                            valid = true;
                            location = null;
                        }
                        else
                        {
                            valid = PointFugoImpl.TryParse(an_str, out location);
                        }

                        if (!valid)
                        {
                            // ͂sÓȂ̂ŁA[vB
                            goto gt_PlayerPieceContinue;
                        }
                    }
                    // œ͂ÓƕB̂ƏB

                    if (an_str == "stop")
                    {
                        // [v甲܂B
                        isContinuePhase = false;
                        goto gt_PlayerPieceContinue;
                    }
                    else
                    {
                        taikyoku.Goban.Put(location, taikyoku.YourColor);

                        Util_PrintBoard.ShowBoard(taikyoku);
                    }
                }
                else
                {
                    //
                    // w肵ꏊAilԁj̐΂ɒu鏈łB
                    //
                    Console.Write("My piece? ");
                    string an_str = Console.ReadLine();
                    //scanf("%s", an);

                    //----------------------------------------
                    // Óȓ͂܂ŁA邭񂵂܂B
                    //----------------------------------------
                    {//2015-11-27 ǉ
                        bool valid = false;

                        if (an_str == "stop")
                        {
                            valid = true;
                            location = null;
                        }
                        else
                        {
                            valid = PointFugoImpl.TryParse(an_str, out location);
                        }

                        if (!valid)
                        {
                            // ͂sÓȂ̂ŁA[vB
                            goto gt_PlayerPieceContinue;
                        }
                    }
                    // œ͂ÓƕB̂ƏB

                    if (an_str == "stop")
                    {
                        // [v甲܂B
                        isContinuePhase = false;
                        goto gt_PlayerPieceContinue;
                    }
                    else
                    {
                        taikyoku.Goban.Put(location, taikyoku.MyColor);
                        Util_PrintBoard.ShowBoard(taikyoku);
                    }
                }
                youMeCounter++;

            gt_PlayerPieceContinue:
                ;
            }
            while (isContinuePhase);
        }

        /// <summary>
        /// 󂫃Xy[XAǂ̐wn肵A̐wn̐΂ɕϊ܂B
        /// </summary>
        public static void FillStones
        (
            Taikyoku taikyoku
        )
        {
            for (int i = 0; i < Const_Board.BOARD_SIZE; i++)
            {
                for (int j = 0; j < Const_Board.BOARD_SIZE; j++)
                {
                    GobanPoint ijLocation = new GobanPointImpl(i, j);
                    if (taikyoku.Goban.LookColor(ijLocation) == StoneColor.Empty)
                    {
                        taikyoku.Goban.Put(ijLocation, Util_SeitiZi.Test_SeitiZi(ijLocation, taikyoku));
                    }
                }
            }
        }

        /// <summary>
        /// Տ̐΂𐔂܂B
        /// </summary>
        public static void CountPieces
        (
            out int out_myTotal, // Gnugo1.2 ł mtot ƂϐBmy total ̗낤H
            out int out_yourTotal, // Gnugo1.2 ł utot ƂϐByour total ̗낤H
            Taikyoku taikyoku
        )
        {
            out_myTotal = 0;
            out_yourTotal = 0;

            for (int i = 0; i < Const_Board.BOARD_SIZE; i++)
            {
                for (int j = 0; j < Const_Board.BOARD_SIZE; j++)
                {
                    GobanPoint ijLocation = new GobanPointImpl(i, j);
                    if (taikyoku.Goban.LookColor(ijLocation) == taikyoku.MyColor)
                    {
                        ++out_myTotal;
                    }
                    else if (taikyoku.Goban.LookColor(ijLocation) == taikyoku.YourColor)
                    {
                        ++out_yourTotal;
                    }
                }
            }
        }
    }
}